/* 
 * Copyright (c) 1990, 1991, 1992, 1994, The University of Utah and
 * the Computer Systems Laboratory at the University of Utah (CSL).
 * All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software is hereby
 * granted provided that (1) source code retains these copyright, permission,
 * and disclaimer notices, and (2) redistributions including binaries
 * reproduce the notices in supporting documentation, and (3) all advertising
 * materials mentioning features or use of this software display the following
 * acknowledgement: ``This product includes software developed by the
 * Computer Systems Laboratory at the University of Utah.''
 *
 * THE UNIVERSITY OF UTAH AND CSL ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS
 * IS" CONDITION.  THE UNIVERSITY OF UTAH AND CSL DISCLAIM ANY LIABILITY OF
 * ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * CSL requests users of this software to return to csl-dist@cs.utah.edu any
 * improvements that they make and grant CSL redistribution rights.
 *
 * 	Utah $Hdr: vm_param.h 1.19 95/05/05$
 */

#ifndef	_MACH_PARISC_VM_PARAM_H_
#define _MACH_PARISC_VM_PARAM_H_

#define BYTE_SIZE	8	/* byte size in bits */

#define PARISC_PGBYTES	4096	/* bytes per hp800 page */
#define PARISC_PGSHIFT	12	/* number of bits to shift for pages */
#define PAGE_SHIFT	PARISC_PGSHIFT

#define VM_MIN_ADDRESS	((vm_offset_t) 0)
#define VM_MAX_ADDRESS	((vm_offset_t) 0xfffff000)

#define parisc_round_page(x)	((((unsigned)(x)) + PARISC_PGBYTES - 1) & \
					~(PARISC_PGBYTES-1))
#define parisc_trunc_page(x)	(((unsigned)(x)) & ~(PARISC_PGBYTES-1))

#define STACK_GROWTH_UP	1

#ifdef	ASSEMBLER
#define PARISC_STACK_START	0x68FF3000  /* HP-UX Magic */
#else	ASSEMBLER
#define PARISC_STACK_START	((vm_offset_t) 0x68FF3000)  /* HP-UX Magic */
#endif	ASSEMBLER
#define PARISC_STACK_SIZE	((vm_size_t)(128*1024))

#endif	/* _MACH_PARISC_VM_PARAM_H_ */
