/* 
 * Copyright (c) 1988, 1992, 1994, The University of Utah and
 * the Computer Systems Laboratory at the University of Utah (CSL).
 * All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software is hereby
 * granted provided that (1) source code retains these copyright, permission,
 * and disclaimer notices, and (2) redistributions including binaries
 * reproduce the notices in supporting documentation, and (3) all advertising
 * materials mentioning features or use of this software display the following
 * acknowledgement: ``This product includes software developed by the
 * Computer Systems Laboratory at the University of Utah.''
 *
 * THE UNIVERSITY OF UTAH AND CSL ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS
 * IS" CONDITION.  THE UNIVERSITY OF UTAH AND CSL DISCLAIM ANY LIABILITY OF
 * ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * CSL requests users of this software to return to csl-dist@cs.utah.edu any
 * improvements that they make and grant CSL redistribution rights.
 *
 * 	Utah $Hdr: cpu.h 1.16 95/04/26$
 */
#ifndef _PARISC_CPU_H_
#define _PARISC_CPU_H_

/* values for machineid (S:supported, U:unsupported) */
#define	HP_840		0x004	/* [U] Indigo */
#define	HP_825		0x008	/* [U] Firefox */
#define	HP_835		0x00A	/* [S] 834, 835, 836 */
#define	HP_845		0x00B	/* [S] 844, 845, 846 (change cio to slot 8) */
#define	HP_850_OLD	0x00C	/* [U] Cheetah (old PDC cpu type) */
#define	HP_850		0x080	/* [U] Cheetah */
#define	HP_855		0x081	/* [U] Jaguar */
#define	HP_810		0x100	/* [U] Burgundy */
#define HP_820		0x101   /* [U] */
#define HP_832		0x102   /* [U] 827, 832 */
#define HP_815		0x103   /* [U] 808, 815 */

#define	HP_720		0x200	/* [S] Cobra */
#define	HP_750		0x201	/* [S] Coral */
#define	HP_730		0x202	/* [S] King Cobra */

#define	HP_710		0x300	/* [S] Bushmaster */
#define	HP_705		0x302	/* [S] Bushmaster */

#define	HP_715_33	0x311	/* [S] Scorpio */
#define	HP_715_50	0x310	/* [S] Scorpio */
#define	HP_715T_50	0x312	/* [S] Scorpio (upgrade from 4XXt) */
#define	HP_715S_50	0x314	/* [S] Scorpio (upgrade from 4XXs) */
#define	HP_715_75	0x316	/* [S] Scorpio */
#define	HP_725		0xFFF	/* [S] Scorpio -- is this the real ID? */
#define	HP_735		0x203	/* [S] Hardball */
#define HP_735_125	0x206	/* [S] Hardball */
#define	HP_755		0xFFD	/* [S] Coral II -- is this the real ID? */

#define	HP_712_60	0x600	/* [S] Gekko */
#define	HP_712_80	0x601	/* [S] Gekko */
#define	HP_712_3	0x602	/* [S] Gekko */
#define	HP_712_4	0x605	/* [S] Gekko */

#define	HP_715_100	0x60B	/* [S] */

/* values for cpuspeed */
#define	MHZ_15		15	/* supported HP800s */
#define	MHZ_33		33	/* HP715/33 */
#define	MHZ_50		50	/* HP705, 710, 720, 730, 715/50, 725 */
#define	MHZ_60		60	/* HP712/60 */
#define	MHZ_66		66	/* HP750 */
#define	MHZ_75		75	/* HP715/75 */
#define	MHZ_80		80	/* HP712/80 */
#define	MHZ_99		99	/* HP735, 755 */
#define MHZ_100		100	/* HP715/100 */
#define MHZ_125		125	/* HP735/125, 755/125 */

/*
 * Wordsize for PA-RISC processors is 4 bytes (32 bits)
 */
#define	WORD_SIZE	4
#define	WORD_SIZE_BITS	32

/*
 * The following are used by the HP-UX FP emulation code.
 * The variable `copr_sfu_config' may have the following bits set.
 */
#define	COPR_FP		0x00000080	/* Floating Point coprocessor */
#define	SFU_MPY_DIVIDE	0x00008000	/* Multiply/Divide SFU (unused) */

/*
 *  The following are used by the HP-UX I/O subsystem.
 */
#define	CPU_IOLINE	32		/* bytes in a MIDBUS transfer */
#define	ALIGN_IOBUF(P)	((char *)(((int)(P) + CPU_IOLINE-1) & ~(CPU_IOLINE-1)))

/*
 * Expected (and optimized for) cache line size (in bytes).
 */
#define CACHE_LINE_SIZE	32


#include_next "cpu.h"

#endif _PARISC_CPU_H_
