/* 
 * Copyright (c) 1990, 1991, 1994 The University of Utah and
 * the Computer Systems Laboratory at the University of Utah (CSL).
 * All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software is hereby
 * granted provided that (1) source code retains these copyright, permission,
 * and disclaimer notices, and (2) redistributions including binaries
 * reproduce the notices in supporting documentation, and (3) all advertising
 * materials mentioning features or use of this software display the following
 * acknowledgement: ``This product includes software developed by the
 * Computer Systems Laboratory at the University of Utah.''
 *
 * THE UNIVERSITY OF UTAH AND CSL ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS
 * IS" CONDITION.  THE UNIVERSITY OF UTAH AND CSL DISCLAIM ANY LIABILITY OF
 * ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * CSL requests users of this software to return to csl-dist@cs.utah.edu any
 * improvements that they make and grant CSL redistribution rights.
 *
 * 	Utah $Hdr: debug.h 1.3 94/12/14$
 *	Author: Bob Wheeler and Bryan Ford, University of Utah CSL
 */

#ifndef _PARISC_DEBUG_H_
#define _PARISC_DEBUG_H_

#ifndef ASSEMBLER

#include <kern/debug.h>

#if 0
		register int _r4 __asm("r4") = 0xbadd00de;			\
		if (_r4 != 0xbadd00de) { here(); panic("r4 munched"); }		\

#endif

#define check_save_regs(expr)							\
	({									\
		int _array[64]; int i;						\
		register int _r5 __asm("r5") = 0xabadcafe;			\
		register int _r6 __asm("r6") = 0xdeadbeef;			\
		register int _r7 __asm("r7") = 0x0badf00d;			\
		register int _r8 __asm("r8") = 0x12345678;			\
		register int _r9 __asm("r9") = 0x23456789;			\
		register int _r10 __asm("r10") = 0x3456789a;			\
		register int _r11 __asm("r11") = 0x456789ab;			\
		register int _r12 __asm("r12") = 0x56789abc;			\
		register int _r13 __asm("r13") = 0x6789abcd;			\
		register int _r14 __asm("r14") = 0x789abcde;			\
		register int _r15 __asm("r15") = 0x89abcdef;			\
		register int _r16 __asm("r16") = 0x9abcdef0;			\
		register int _r17 __asm("r17") = 0xabcdef01;			\
		register int _r18 __asm("r18") = 0xbcdef012;			\
		for (i = 0; i < 64; i++) _array[i] = 0xdeadf00d;		\
		{ expr; }							\
		if (_r5 != 0xabadcafe) { here(); panic("r5 munched"); }		\
		if (_r6 != 0xdeadbeef) { here(); panic("r6 munched"); }		\
		if (_r7 != 0x0badf00d) { here(); panic("r7 munched"); }		\
		if (_r8 != 0x12345678) { here(); panic("r8 munched"); }		\
		if (_r9 != 0x23456789) { here(); panic("r9 munched"); }		\
		if (_r10 != 0x3456789a) { here(); panic("r10 munched"); }	\
		if (_r11 != 0x456789ab) { here(); panic("r11 munched"); }	\
		if (_r12 != 0x56789abc) { here(); panic("r12 munched"); }	\
		if (_r13 != 0x6789abcd) { here(); panic("r13 munched"); }	\
		if (_r14 != 0x789abcde) { here(); panic("r14 munched"); }	\
		if (_r15 != 0x89abcdef) { here(); panic("r15 munched"); }	\
		if (_r16 != 0x9abcdef0) { here(); panic("r16 munched"); }	\
		if (_r17 != 0xabcdef01) { here(); panic("r17 munched"); }	\
		if (_r18 != 0xbcdef012) { here(); panic("r18 munched"); }	\
		for (i = 0; i < 64; i++)					\
			if (_array[i] != 0xdeadf00d)				\
				{ here(); panic("stack munched"); }		\
	})

#else	/* ASSEMBLER */

/*
 *	Debug support for assembly code.
 */

#define dump_save_registers(t1,t2) \
	stw	r1,SS_R1(t1) !\
	stw	r2,SS_R2(t1) !\
	stw	r3,SS_R3(t1) !\
	stw	r4,SS_R4(t1) !\
	stw	r5,SS_R5(t1) !\
	stw	r6,SS_R6(t1) !\
	stw	r7,SS_R7(t1) !\
	stw	r8,SS_R8(t1) !\
	stw	r9,SS_R9(t1) !\
	stw	r10,SS_R10(t1) !\
	stw	r11,SS_R11(t1) !\
	stw	r12,SS_R12(t1) !\
	stw	r13,SS_R13(t1) !\
	stw	r14,SS_R14(t1) !\
	stw	r15,SS_R15(t1) !\
	stw	r16,SS_R16(t1) !\
	stw	r17,SS_R17(t1) !\
	stw	r18,SS_R18(t1) !\
	stw	r19,SS_R19(t1) !\
	stw	r20,SS_R20(t1) !\
	stw	r21,SS_R21(t1) !\
	stw	r22,SS_R22(t1) !\
	stw	r23,SS_R23(t1) !\
	stw	r24,SS_R24(t1) !\
	stw	r25,SS_R25(t1) !\
	stw	r26,SS_R26(t1) !\
	stw	r27,SS_R27(t1) !\
	stw	r28,SS_R28(t1) !\
	stw	r29,SS_R29(t1) !\
	stw	r30,SS_R30(t1) !\
	stw	r31,SS_R31(t1)

#define dump_save_spaces(t1,t2) \
	mfsp	sr0,t2 !\
	stw	t2,SS_SR0(t1) !\
	mfsp	sr1,t2 !\
	stw	t2,SS_SR1(t1) !\
	mfsp	sr2,t2 !\
	stw	t2,SS_SR2(t1) !\
	mfsp	sr3,t2 !\
	stw	t2,SS_SR3(t1) !\
	mfsp	sr4,t2 !\
	stw	t2,SS_SR4(t1) !\
	mfsp	sr5,t2 !\
	stw	t2,SS_SR5(t1) !\
	mfsp	sr6,t2 !\
	stw	t2,SS_SR6(t1) !\
	mfsp	sr7,t2 !\
	stw	t2,SS_SR7(t1)

#define dump_save_control(t1,t2) \
	mfctl	cr8,t2 !\
	stw	t2,SS_CR8(t1) !\
	mfctl	cr9,t2 !\
	stw	t2,SS_CR9(t1) !\
	mfctl	cr11,t2 !\
	stw	t2,SS_CR11(t1) !\
	mfctl	cr12,t2 !\
	stw	t2,SS_CR12(t1) !\
	mfctl	cr13,t2 !\
	stw	t2,SS_CR13(t1) !\
	mfctl	cr15,t2 !\
	stw	t2,SS_CR15(t1) !\
	mfctl	cr19,t2 !\
	stw	t2,SS_CR19(t1) !\
	mfctl	cr20,t2 !\
	stw	t2,SS_CR20(t1) !\
	mfctl	cr21,t2 !\
	stw	t2,SS_CR21(t1) !\
	mfctl	cr22,t2 !\
	stw	t2,SS_CR22(t1)

#endif	/* ASSEMBLER */

#endif	/* _PARISC_DEBUG_H_ */
