;  Copyright (c) 1989-1994 The University of Utah and
;  the Computer Systems Laboratory at the University of Utah (CSL).
;  All rights reserved.
; 
;  Permission to use, copy, modify and distribute this software is hereby
;  granted provided that (1) source code retains these copyright, permission,
;  and disclaimer notices, and (2) redistributions including binaries
;  reproduce the notices in supporting documentation, and (3) all advertising
;  materials mentioning features or use of this software display the following
;  acknowledgement: ``This product includes software developed by the
;  Computer Systems Laboratory at the University of Utah.''
; 
;  THE UNIVERSITY OF UTAH AND CSL ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS
;  IS" CONDITION.  THE UNIVERSITY OF UTAH AND CSL DISCLAIM ANY LIABILITY OF
;  ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
; 
;  CSL requests users of this software to return to csl-dist@cs.utah.edu any
;  improvements that they make and grant CSL redistribution rights.
; 
;	Utah $Hdr: setjmp.s 1.7 94/12/14$
;
;/* This version modified by Patrick Dalton 04/02/92
; * from version in /usr/src/lib/libc/hppa/gen/setjmp.s
; *
; * All code that is dependent on signal has been taken out.
; * Code modified for internal kernel use only.
; */

#include <machine/asm.h>

;
; C library -- setjmp, longjmp
;
;	longjmp(a,v)
; will generate a "return(v)" from
; the last call to
;	setjmp(a)
; by restoring registers.
;

;
; Layout of jmp_buf (48 words).
;
;	0	saved general registers (gr3-18,27)
;	17	saved return pointer
;	18	saved stack pointer
;

        .SPACE $TEXT$
        .SUBSPA $CODE$
	.EXPORT _setjmp
_setjmp	.PROC
	.CALLINFO
	.ENTRY

;
; Save the other general registers whose contents are expected to remain
; across function calls.  According to the "HP9000 Series 800 Assembly
; Language Reference Manual", procedures can use general registers 19-26,
; 28, 29, 1, and 31 without restoring them.  Hence, we do not save these.
;
	stwm	r3,4(arg0)
	stwm	r4,4(arg0)
	stwm	r5,4(arg0)
	stwm	r6,4(arg0)
	stwm	r7,4(arg0)
	stwm	r8,4(arg0)
	stwm	r9,4(arg0)
	stwm	r10,4(arg0)
	stwm	r11,4(arg0)
	stwm	r12,4(arg0)
	stwm	r13,4(arg0)
	stwm	r14,4(arg0)
	stwm	r15,4(arg0)
	stwm	r16,4(arg0)
	stwm	r17,4(arg0)
	stwm	r18,4(arg0)
	stwm	r27,4(arg0)	; Good idea to save the data pointer (dp)
	stwm    rp,4(arg0)	; Save the return pointer
	stwm	sp,4(arg0)	; Save the original stack pointer

	bv      r0(rp)
	or      r0,r0,ret0

	.EXIT
	.PROCEND


        .SPACE $TEXT$
        .SUBSPA $CODE$
	.EXPORT _longjmp
_longjmp .PROC
	.CALLINFO
	.ENTRY

;
; Restore general registers.
;
	ldwm	4(arg0),r3
	ldwm	4(arg0),r4
	ldwm	4(arg0),r5
	ldwm	4(arg0),r6
	ldwm	4(arg0),r7
	ldwm	4(arg0),r8
	ldwm	4(arg0),r9
	ldwm	4(arg0),r10
	ldwm	4(arg0),r11
	ldwm	4(arg0),r12
	ldwm	4(arg0),r13
	ldwm	4(arg0),r14
	ldwm	4(arg0),r15
	ldwm	4(arg0),r16
	ldwm	4(arg0),r17
	ldwm	4(arg0),r18
	ldwm	4(arg0),r27
	ldwm	4(arg0),rp	; Restore return address pointer,
	ldwm	4(arg0),sp	; stack pointer,

	be	0(sr0,rp)		;   and return.
	or	arg1,r0,ret0	; Move return value to where it belongs.

	.EXIT
	.PROCEND



