/* 
 * Copyright (c) 1990,1991,1994 The University of Utah and
 * the Computer Systems Laboratory (CSL).  All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software is hereby
 * granted provided that (1) source code retains these copyright, permission,
 * and disclaimer notices, and (2) redistributions including binaries
 * reproduce the notices in supporting documentation, and (3) all advertising
 * materials mentioning features or use of this software display the following
 * acknowledgement: ``This product includes software developed by the
 * Computer Systems Laboratory at the University of Utah.''
 *
 * THE UNIVERSITY OF UTAH AND CSL ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS
 * IS" CONDITION.  THE UNIVERSITY OF UTAH AND CSL DISCLAIM ANY LIABILITY OF
 * ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * CSL requests users of this software to return to csl-dist@cs.utah.edu any
 * improvements that they make and grant CSL redistribution rights.
 *
 * 	Utah $Hdr: mdvar.h 1.5 94/12/14$
 *	Author: Mike Hibler, University of Utah CSL
 */

#ifndef MDMAXBYTES
#define MDMAXBYTES	(8*1024*1024)	/* max memory for MDs */
#endif
#define MDMINBYTES	(2*1024*1024)	/* min reasonable size */
#define MDLEAVEBYTES	(4*1024*1024)	/* must leave this much memory */

/*
 * A memory disk is described at config time by this structure.
 */
struct mddevice {
	int	md_unit;		/* logical unit of this md */
	caddr_t	md_start;		/* RAM offset of md */
	long	md_size;		/* size of md */
	int	md_flags;		/* misc. information */
};

#ifdef KERNEL
#if 0
extern struct mddevice mddevice[];
#endif
#if MACH_KERNEL
extern vm_offset_t mdbase;
#else
extern char mdbase[];
#endif
#endif
